%{?build_gost}%{?!build_gost:%bcond_with gost}
%{?build_gurpmi}%{?!build_gurpmi:%bcond_without gurpmi}
%{?build_default_wget}%{?!build_default_wget:%bcond_without default_wget}

Name:		urpmi
Version:	7.32.3
Release:	47
Summary:	Command-line software installation tools

Group:		System/Configuration/Packaging
License:	GPLv2+
Source0:	%{name}-%{version}.tar.xz
# TODO: upload to upstream
Source1:	ru.po

# Always download xml-info files
Patch1:         urpmi-7.32.2-always-xml-info.patch

%if %{with gost}
# Support for custom Curl (e.g., with GOST support)
Patch2:         urpmi-7.32.2-curl_gost.patch
%endif

# Drop dudf completely
Patch3:         urpmi-7.32.2-disable-orphan-dudf.patch

# Set '--download-all' by default
Patch4:         urpmi-7.32.2-download-all.patch

# Try to avoid some warnings when running not in terminal
Patch5:         urpmi-7.32.2-drop-terminal-size-warnings.patch

Patch6:         urpmi-7.32.2-look-for-both-name-and-provides.patch

# Drop --anyauth for curl - conflicts with private repos in ABF
Patch7:         urpmi-7.32.2.no_anyauth_curl.patch

# By default, don't calculate orohans
Patch8:         urpmi-7.32.2-no-orphans-by-default.patch

# In case of synthesis parse error, disable media for the current session,
# not forever
Patch9:         urpmi-7.32.2-repo-disable-on-parse-error.patch

Patch10:        urpmi-7.32.2-rosa-mirrors.patch

Patch12:        urpmi-7.32.2-show-full-what-requires.patch

# By default, automatically choose the best alternative
Patch13:	urpmi-7.32.2-auto-req.patch

Patch15:	urpmi-7.32.2-auto-media-update.patch

Patch16:	urpmi-7.32.2-urpmq-fuzzy-by-default.patch

Patch17:	urpmi-7.32.3-allow-media-without-keys.patch

Patch18:	urpmi-7.32.3-no-enable_exceptions2.patch

Patch19:	urpmi-7.32.3-restricted-in-config.patch

# For update from rosa2012.1 to 2014.1, it is really nice to update shared-mime-info
# in the first order (since it will speed up post scripts significantly)
# Also update wget and curl along with aria2
Patch20:	urpmi-7.32.3-more-priorities.patch

# Automatically add remote media (if possible) when installing remote files
Patch21:	urpmi-7.32.3-auto-media.patch

# Disable mirror selection by timezone. This selection was broken for a long time,
# but once we have fixed it, it proved to be quite ugly.
Patch23:	urpmi-7.32.3-disable-timezone-for-mirrors.patch

# %if %{with default_wget}
%if %{with gost}
# Use wget by default - curl introduces problems from time to time
# (such as broken download indicator)
Patch24:        urpmi-7.32.3-use-wget-by-default-gost.patch
%else
Patch241:        urpmi-7.32.3-use-wget-by-default.patch
%endif

# TODO: it seems that the problem comes from other place,
# this is just a workaround to avoid noisy messages
Patch25:        urpmi-7.32.3-avoid-empty-transactions.patch

# These warnings exist for years, time to drop them
Patch26:        urpmi-7.32.3-drop-obsolete-warnings.patch

# Adopt gurpmi for parsing wget 1.16 progress bar
Patch27:        urpmi-7.32.3-wget-1.16-output.patch

# More debug output
#Patch28:	urpmi-7.32.3-report-pkgs-removed-from-trans.patch

# Display packages in bash completion for urpmq
Patch29:	urpmi-7.32.3-urpmq-bash-completion.patch

Patch30:	urpmi-7.32.3-wget-auth-no-challenge.patch

# Control media to be added by default by media.cfg only, drop hardcoded
# selection on the basis of distribution type
Patch31:	urpmi-7.32.3-control-media-addition-by-media.cfg-only.patch

# Pedantic fix - "rpm -U" instead of "rpm -iU"
Patch32:	urpmi-7.32.3-fix-rpm-invocation-in-urpmi-recover.patch

Patch33:	urpmi-7.32.3-fix-msg-on-script-failure.patch

Patch34:	urpmi-7.32.3-urpmi.recover_message.patch

Patch35:	urpmi-7.32.3-kernel-orphans.patch

URL:		http://wiki.mandriva.com/en/Tools/urpmi
Requires:	webfetch gnupg
Requires(post):	perl-Locale-gettext
Requires(post):	perl-URPM >= 4.62-3
# gzip is used in perl-URPM for synthesis and hdlist
Requires(post):	gzip
Requires:	genhdlist2
Requires:	meta-task
Requires:	usermode-consoleonly
# Set versions to force these modules to be updated together with urpmi
# to avoid breakage of urpmi and perl-URPM when updating from previous releases
# (that used perl 5.12)
Requires:	perl-Locale-gettext >= 1.50.0-13
Requires:	perl-Term-ReadKey >= 2.320.0-3
Requires:	perl-XML-LibXML >= 2.11.700-1
Requires:	perl-Time-ZoneInfo >= 0.300.0-12
Requires:	perl-Filesys-Df >= 0.920.0-15
# For urpmi.recover
Requires:	urpm-tools
Requires:	perl(Date::Manip)
Requires:	faketime

# /update
Suggests:	perl-Hal-Cdroms
Suggests:	aria2
BuildRequires:	bzip2-devel
BuildRequires:	gettext intltool
BuildRequires:	perl
BuildRequires:	perl-devel
BuildRequires:	perl-File-Slurp
BuildRequires:	perl(Net::LDAP)
BuildRequires:	perl-URPM
BuildRequires:	perl-MDV-Packdrakeng
BuildRequires:	perl-MDV-Distribconf
BuildRequires:	perl(MDV::Distribconf::Build)
BuildRequires:	perl-Locale-gettext
BuildRequires:  perl_checker
BuildRequires:	intltool
# for make test:
BuildRequires:	perl-Test-Pod
BuildRequires:	perl-XML-LibXML
BuildRequires:  glibc-static-devel
BuildRequires:  perl-Net-Server
# for genhdlist in make test:
BuildRequires:  rpmtools
BuildRequires:  perl-Expect
BuildArch:	noarch
Conflicts:	mdkonline < 2.77.27


%description
urpmi is ROSA Linux's console-based software installation tool. You can
use it to install software from the console in the same way as you use the
graphical Install Software tool (rpmdrake) to install software from the
desktop. urpmi will follow package dependencies -- in other words, it will
install all the other software required by the software you ask it to
install -- and it's capable of obtaining packages from a variety of media,
including the ROSA Linux installation DVD, your local hard disk,
and remote sources such as web or FTP sites.

%if %{with gurpmi}
%package -n	gurpmi
Summary:	User mode rpm GUI install

Requires:	urpmi >= %{EVRD}
Requires:	usermode usermode-consoleonly
Obsoletes:	grpmi
Provides:	grpmi
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

%description -n	gurpmi
gurpmi is a graphical front-end to urpmi.
%endif

%package	parallel-ka-run
Summary:	Parallel extensions to urpmi using ka-run

Requires:	urpmi >= %{EVRD}
#Requires:	parallel-tools

%description	parallel-ka-run
urpmi-parallel-ka-run is an extension module to urpmi for handling
distributed installation using ka-run or Taktuk tools.

%package	parallel-ssh
Summary:	Parallel extensions to urpmi using ssh and scp

Requires:	urpmi >= %{EVRD} openssh-clients perl

%description	parallel-ssh
urpmi-parallel-ssh is an extension module to urpmi for handling
distributed installation using ssh and scp tools.

%package	ldap
Summary:	Extension to urpmi to specify media configuration via LDAP

Requires:	urpmi >= %{EVRD}
Requires:	openldap-clients

%description	ldap
urpmi-ldap is an extension module to urpmi to allow to specify
urpmi configuration (notably media) in an LDAP directory.

%prep
%setup -q

cp %{SOURCE1} po
%apply_patches

#delete unneeded dudf file
rm -f urpm/*dudf*
rm -f pod/8/*dudf*

#fix test count after this
sed -e 's/27/26/' -i t/01compile.t

%build
perl Makefile.PL INSTALLDIRS=vendor \
%if %{with gurpmi}
    --install-gui \
%endif
    --install-po 

%make

# check
# make test

%install
%makeinstall_std

# libexec hacks for ROSA
mv %{buildroot}/usr/libexec/* %{buildroot}%{_sbindir}

# bash completion
install -m644 %{name}.bash-completion -D %{buildroot}%{_sysconfdir}/bash_completion.d/%{name}

# rpm-find-leaves is invoked by this name in rpmdrake
ln -sf rpm-find-leaves %{buildroot}%{_bindir}/urpmi_rpm-find-leaves

# Don't install READMEs twice
rm -f %{buildroot}%{perl_vendorlib}/urpm/README*

# This is not installed by 'make install' yet
mkdir %{buildroot}/etc/urpmi/urpmicfg.d

# Desktop entry (only used to register new MIME type handler, so no icon etc.)
%if %{with gurpmi}
mkdir -p %{buildroot}%{_datadir}/applications
cp -a gurpmi.desktop %{buildroot}%{_datadir}/applications/mandriva-gurpmi.desktop

# Old gurpmi doesn't work in any case, but is still invoked by some tools
rm -f %{buildroot}%{_bindir}/gurpmi
cp %{buildroot}%{_sbindir}/gurpmi2 %{buildroot}%{_sbindir}/gurpmi
%endif

%if %{with gurpmi}
mkdir -p %{buildroot}%{_datadir}/mime/packages
cat > %{buildroot}%{_datadir}/mime/packages/gurpmi.xml << EOF
<?xml version="1.0"?>
<mime-info xmlns="http://www.freedesktop.org/standards/shared-mime-info">
  <mime-type type="application/x-urpmi">
    <comment>urpmi file</comment>
    <glob pattern="*.urpmi"/>
  </mime-type>
</mime-info>
EOF
%else
rm -f %{buildroot}/%{perl_vendorlib}/gurpm/RPMProgressDialog.pm
%endif

# consolehelper configuration
# ask for user password
for pak in urpmi urpme; do
    ln -sf %{_bindir}/consolehelper %{buildroot}%{_bindir}/$pak
done

%if %{with gurpmi}
for pak in gurpmi gurpmi2; do
    ln -sf %{_bindir}/consolehelper %{buildroot}%{_bindir}/$pak
done
%endif

mkdir -p %{buildroot}%{_sysconfdir}/pam.d/
mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps

%if %{with gurpmi}
for pak in urpmi urpme gurpmi gurpmi2; do
%else
for pak in urpmi urpme; do
%endif
cat > %{buildroot}%{_sysconfdir}/security/console.apps/$pak <<EOF
USER=root
PROGRAM=/usr/sbin/$pak
FALLBACK=false
SESSION=true
EOF

cat > %{buildroot}%{_sysconfdir}/pam.d/$pak  <<EOF
#%PAM-1.0
auth		include		config-util
account		include		config-util
session		include		config-util
EOF

done

#don't ask root password
ln -sf %{_bindir}/consolehelper %{buildroot}%{_bindir}/urpmi.update

cat > %{buildroot}%{_sysconfdir}/security/console.apps/urpmi.update <<EOF
USER=root
PROGRAM=/usr/sbin/urpmi.update
FALLBACK=false
SESSION=true
EOF

cat > %{buildroot}%{_sysconfdir}/pam.d/urpmi.update  <<EOF
#%PAM-1.0
auth		include		config-util-user
account		include		config-util-user
session		include		config-util-user
EOF

%find_lang %{name}

%pre
rm -f %{_bindir}/urpme
rm -f %{_bindir}/urpmi
rm -f %{_sysconfdir}/pam.d/urpme
rm -f %{_sysconfdir}/pam.d/urpmi

%preun
if [ "$1" = "0" ]; then
  cd /var/lib/urpmi
  rm -f compss provides depslist* descriptions.* *.cache hdlist.* synthesis.hdlist.* list.*
  cd /var/cache/urpmi
  rm -rf partial/* headers/* rpms/*
fi
exit 0

%files -f %{name}.lang
%doc NEWS README.zeroconf urpmi-repository-http.service
%dir /etc/urpmi
%dir /var/lib/urpmi
%dir /var/cache/urpmi
%dir /var/cache/urpmi/partial
%dir /var/cache/urpmi/headers
%dir /var/cache/urpmi/rpms
%dir /etc/urpmi/urpmicfg.d
%config(noreplace) /etc/urpmi/skip.list
%config(noreplace) /etc/urpmi/inst.list
%{_sysconfdir}/bash_completion.d/%{name}
%{_sysconfdir}/pam.d/urpme
%{_sysconfdir}/pam.d/urpmi
%{_sysconfdir}/pam.d/urpmi.update
%{_sysconfdir}/security/console.apps/urpme
%{_sysconfdir}/security/console.apps/urpmi
%{_sysconfdir}/security/console.apps/urpmi.update
%{_bindir}/urpme
%{_bindir}/urpmi
%{_bindir}/urpmi.update
%{_bindir}/urpmi_rpm-find-leaves
%{_bindir}/rpm-find-leaves
%{_bindir}/urpmf
%{_bindir}/urpmq
%{_sbindir}/urpmi
%{_sbindir}/rurpmi
%{_sbindir}/rurpme
%{_sbindir}/urpme
%{_sbindir}/urpmi.addmedia
%{_sbindir}/urpmi.removemedia
%{_sbindir}/urpmi.update
%{_sbindir}/urpmi.recover
%{_mandir}/man3/*urpm*
%{_mandir}/man5/urpm*
%{_mandir}/man5/proxy*
%{_mandir}/man8/rurpm*
%{_mandir}/man8/urpme*
%{_mandir}/man8/urpmf*
%{_mandir}/man8/urpmq*
%{_mandir}/man8/urpmi.8*
%{_mandir}/man8/urpmi.addmedia*
%{_mandir}/man8/urpmi.removemedia*
%{_mandir}/man8/urpmi.recover*
%{_mandir}/man8/urpmi.update*
%{_mandir}/man8/urpmihowto*
%dir %{perl_vendorlib}/urpm
%{perl_vendorlib}/urpm.pm
%{perl_vendorlib}/urpm/args.pm
%{perl_vendorlib}/urpm/bug_report.pm
%{perl_vendorlib}/urpm/cfg.pm
%{perl_vendorlib}/urpm/cdrom.pm
%{perl_vendorlib}/urpm/download.pm
%{perl_vendorlib}/urpm/get_pkgs.pm
%{perl_vendorlib}/urpm/install.pm
%{perl_vendorlib}/urpm/lock.pm
%{perl_vendorlib}/urpm/main_loop.pm
%{perl_vendorlib}/urpm/md5sum.pm
%{perl_vendorlib}/urpm/media.pm
%{perl_vendorlib}/urpm/mirrors.pm
%{perl_vendorlib}/urpm/msg.pm
%{perl_vendorlib}/urpm/orphans.pm
%{perl_vendorlib}/urpm/parallel.pm
%{perl_vendorlib}/urpm/prompt.pm
%{perl_vendorlib}/urpm/removable.pm
%{perl_vendorlib}/urpm/select.pm
%{perl_vendorlib}/urpm/signature.pm
%{perl_vendorlib}/urpm/sys.pm
%{perl_vendorlib}/urpm/util.pm
%{perl_vendorlib}/urpm/xml_info.pm
%{perl_vendorlib}/urpm/xml_info_pkg.pm

%if %{with gurpmi}
%files -n gurpmi
%{_bindir}/gurpmi
%{_bindir}/gurpmi2
%{_sbindir}/gurpmi
%{_sbindir}/gurpmi2
%{_datadir}/applications/mandriva-gurpmi.desktop
%{_datadir}/mime/packages/gurpmi.xml
%{perl_vendorlib}/gurpmi.pm
%{perl_vendorlib}/gurpm/RPMProgressDialog.pm
%{_sysconfdir}/pam.d/gurpmi2
%{_sysconfdir}/pam.d/gurpmi
%{_sysconfdir}/security/console.apps/gurpmi2
%{_sysconfdir}/security/console.apps/gurpmi
%endif

%files parallel-ka-run
%doc urpm/README.ka-run
%dir %{perl_vendorlib}/urpm
%{perl_vendorlib}/urpm/parallel_ka_run.pm

%files parallel-ssh
%doc urpm/README.ssh
%dir %{perl_vendorlib}/urpm
%{perl_vendorlib}/urpm/parallel_ssh.pm

%files ldap
%doc urpmi.schema
%{perl_vendorlib}/urpm/ldap.pm




%changelog

* Tue Apr 26 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 7.32.3-47
- (b8693c7) Add wget and curl to highest priority packages list

* Thu Feb 04 2016 Denis Silakov <dsilakov@gmail.com> 7.32.3-46
- (2254693) Do not remove requirements of current kernel during orphans removal

* Tue Jan 12 2016 Denis Silakov <dsilakov@gmail.com> 7.32.3-45
- (341457b) Fix typo in ru.po

* Sat Dec 26 2015 Denis Silakov <dsilakov@gmail.com> 7.32.3-44
- (0528610) Fix message in urpmi.recover

* Wed Dec 02 2015 Denis Silakov <dsilakov@gmail.com> 7.32.3-43
- (d1b8c5d) Fix error message in case of scriptlet failure

* Mon Jun 08 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-42
- (bf24171) Pedantic fix - use 'rpm -U' instead of 'rpm -iU'

* Fri Mar 20 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-41
- (01ac160) Add support for ROSA Enterprise Desktop mirrors

* Sat Mar 07 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-40
- (307b255) Merge rosa-release and 'control-media-addition-by-media.cfg-only' patches
- (Denis Silakov: 9e7b7d5) Rework last patch - let's control media added by default only by media.cfg, since we don't have several edditions of Desktop Fresh now

* Fri Mar 06 2015 Konstantin Vlasov <konstantin.vlasov@rosalab.ru> 7.32.3-39
- (e39fb59) Ignoring all non-regular media by default
- (e39fb59) If medium is of type backports, debug, source, or testing, it will be ignored by default (affects e.g. "non-free testing" which was not ignored).

* Tue Feb 24 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-38
- (44f7d0e) Add --auth-no-challeng to wget default options - to work with closed repos in ABF

* Sun Feb 22 2015 Alexander Lakhin <a.lahin@ntcit-rosa.ru> 7.32.3-37
- (aa4aa17) MassBuild#656: Increase release tag

* Fri Feb 20 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-36
- (6f0319f) Workaround dummy rpm patch processing
- (Denis Silakov: d48fa76) Fix default wget patch for the case when curl_gost is present
- (Denis Silakov: eea6af4) Use wget by default in all platforms

* Fri Feb 13 2015 Konstantin Vlasov <konstantin.vlasov@rosalab.ru> 7.32.3-35
- (f46dc2b) urpmq auto-completion: added packages

* Fri Feb 06 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-34
- (8cef7d5) Add a patch for more debug output (for rarecases of strange transaction creation)

* Wed Feb 04 2015 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-30
- (8601d84) Drop unused patch
- (Denis Silakov: 70847c9) Fix wget-progress-bar patch
- (Denis Silakov: 50c8680) Fix conditional builds, added patch to parse wget 1.16 progress bar
- (Denis Silakov: 6c3734a) Make default-wget patch conditional

* Mon Dec 22 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-26
- (35e6597) Fix download-all by default patch

* Sun Nov 30 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-25
- (0108ce7) Drop obsolete warnings

* Wed Nov 12 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-24
- (886cb09) Avoid 'invalid transaction size' errors

* Thu Nov 06 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-23
- (77835f3) Improve wget-by-default patch - make other programs recognize that wget will be used

* Wed Nov 05 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-22
- (dbcde22) Fix wget-by-default patch
- (Denis Silakov: ca741e1) Use wget as a default downloader

* Mon Oct 20 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-21
- (dd01d91) Really disable timezone

* Fri Oct 17 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-20
- (1a1ee1b) Disable perl-timezone usage when choosing a mirror

* Wed Oct 15 2014 Denis Silakov <denis.silakov@rosalab.ru> 7.32.3-19
- (f036a5c) Improved Russian translation


